ad_page_contract {

	@author Fabrizio Sotgiu <fabrizio@esode.it>
	@creation date January 16, 2006
	@version 0.1d

} 

package require http
package require tls

http::register https 443 ::tls::socket
  
set post_data [ ns_conn form ]

set fingerprint [ ns_set get $post_data custom ]
set id_pass [split $fingerprint :]
set transaction_id [lindex $id_pass 0]
set password [lindex $id_pass 1]
set esito [ ns_set get $post_data payment_status ] 
set amount [ ns_set get $post_data mc_gross ]
set txn_id [ ns_set get $post_data txn_id ]

db_0or1row txn_data "select status,password as stored_pw,amount as stored_am,txn_id as stored_txn,status from payment_pending_orders where transaction_id = :transaction_id"

if { $status != "Completed" } {
 
	append postback_query "cmd=_notify-validate"

	for { set i 0 } { $i < [ ns_set size $post_data ] } { incr i } {	
	
		append postback_query "&[ ns_set key $post_data $i ]=[ ns_set value $post_data $i ]"
	
	}

	set validation [http::data [http::geturl "https://www.sandbox.paypal.com/cgi-bin/webscr" -query $postback_query] ]
db_dml set_status { update payment_pending_orders set status=:validation,time=now() where transaction_id=:transaction_id }

	
	if { $validation == "VERIFIED" && $esito == "Completed" && $txn_id != $stored_txn && $amount == $stored_am && $password == $stored_pw } {
		db_multirow requested_classes requested_classes_select {
			select class_key,user_id from payment_pending_memberships where transaction_id=:transaction_id
		} {
			db_transaction {
				db_dml temp_view { create view approveds_count as select community_id,count(user_id) as approveds from dotlrn_member_rels_approved where member_state = 'approved' AND community_id IN (select class_instance_id from dotlrn_class_instances_full where class_key=:class_key and join_policy = 'for fee') group by community_id }
				set community_id [db_string get_community_it "select community_id from approveds_count where approveds = (select min(approveds) from approveds_count) LIMIT 1"]
				dotlrn_community::add_user -member_state approved $community_id $user_id
				db_dml update_txn { update payment_pending_orders set txn_id = :txn_id where transaction_id = :transaction_id}
				db_dml drop_view { drop view approveds_count }
			}
		}
		db_dml set_status { update payment_pending_orders set status=:esito where transaction_id=:transaction_id }
	}
}