ad_page_contract {

	@author Fabrizio Sotgiu <fabrizio@esode.it>
	@creation date January 16, 2006
	@version 0.1d

} {
	class_key:optional
	config:optional
}

set page_title "Manage prices"
set context [ list $page_title ]
set package_id [ ad_conn package_id ]

permission::require_permission -object_id $package_id -privilege admin

if { [ exists_and_not_null class_key ] } {

	set addingprice yes

	ad_form -name set_price -form {
	
		{ class_key:text(hidden) { value "$class_key" } }
		{ price:text { label "Please insert here price"} { maxlegth 10 } }
		
	} -on_submit { 
		set old_price [db_string select_price "select price from payment_course_prices where class_key = :class_key" -default null]
                if { $old_price != "null" } {
			db_dml price_update {
			update payment_course_prices set price = :price where class_key = :class_key }
		} else {
			db_dml price_add { insert into payment_course_prices values (:class_key,:price) }
		}
	
	} -after_submit {
		ad_returnredirect "manage-payment"
	}
	
} elseif { [ exists_and_not_null config ] } {

	set changeconfig yes

	ad_form -name set_config -form {
	
		{ config:text(hidden) { value "$config" } }
		{ config_new_value:text { label "Please insert here $config"} { maxlegth 200 } }
		
	} -on_submit {
		if { $config == "business" } { db_dml update_config { update payment_config set business = :config_new_value } }
		if { $config == "item_name" } { db_dml update_config { update payment_config set item_name = :config_new_value } }
		if { $config == "item_number" } { db_dml update_config { update payment_config set item_number = :config_new_value } }
		if { $config == "url" } { db_dml update_config { update payment_config set url = :config_new_value } } 
	} -after_submit {
		ad_returnredirect "manage-payment"
	}

} else {

	set listing yes

	template::list::create -name pricelist -multirow pricelist -key class_key -elements {
		course_name {
			label "Course name"
			display_template { @pricelist.pretty_name@ }
		}
		price {
			label "Price"
			display_template { @pricelist.price@ }
		}
		set_price {
			link_url_col set_url
			display_template { set price }
		} delete {
			link_url_col delete_url
			display_template {
				<img src="/resources/acs-subsite/Delete16.gif" border="0">
			}
		}
	}
	db_multirow -extend { set_url delete_url }  pricelist pricelist_select {
		select class_key, pretty_name, price from payment_course_prices_full order by pretty_name
	} {
		set set_url [ export_vars -base manage-payment { class_key } ]
		if { [ exists_and_not_null price ] } { set delete_url [ export_vars -base price-delete { class_key } ] }
	}
	
	template::list::create -name config -multirow config -elements {
		business {
			label "Account"
			display_template { <a href="manage-payment?config=business">@config.business@</a> }
		}
		item_name {
			label "Item name"
			display_template { <a href="manage-payment?config=item_name">@config.item_name@</a> }
		}
		item_number {
			label "Item number"
			display_template { <a href="manage-payment?config=item_number">@config.item_number@</a> }
		} 
		url {
			label "URL"
			display_template { <a href="manage-payment?config=url">@config.url@</a> }
		}
	
	}

	db_multirow config config_select {
		select * from payment_config
	}
}
