-- @author Fabrizio Sotgiu <fabrizio@esode.it>
-- @creation-date 2006, 3 February

create table payment_course_prices (
	class_key character varying(100) 
		constraint class_key_pk primary key
		constraint class_key_fk references dotlrn_classes(class_key),
	price numeric(8,2)
);

create table payment_pending_orders (
	transaction_id bigserial constraint transaction_id_pk primary key,
	txn_id character(17),
	password character(10),
	amount numeric(9,2),
	status character varying(15),
	time timestamp	
);

alter sequence payment_pending_orders_transaction_id_seq cycle;

create table payment_pending_memberships (
	transaction_id bigint not null 
		constraint transaction_id_fk references payment_pending_orders(transaction_id),
		user_id integer not null constraint user_id_fk references users(user_id),
		class_key character varying(100) constraint class_key_fk references dotlrn_classes(class_key)
);

create view payment_course_prices_full as
	select c.class_key,c.pretty_name,p.price
	from dotlrn_classes_full c
	left outer join payment_course_prices p
	on c.class_key = p.class_key
;

create table payment_config (
	business character varying(100) not null,
	item_name character varying(100) not null,
	item_number character varying(10) not null,
	url character varying(100) not null
);

insert into payment_config values ('0','0','0','0');

alter table groups drop constraint groups_join_policy_ck;

alter table groups add constraint groups_join_policy_ck check (join_policy::text='open'::text 
	or join_policy::text = 'closed'::text  
	or join_policy::text = 'needs approval'::text 
	or join_policy::text='for fee'::text);
